<script lang="ts">
    import type { InterfaceItem } from './interfaces'

    // Note: storybook can't infer this type, must be declared with docstring
    export let items :InterfaceItem[] = []
</script>

<ul>
    {#each items as item}
        <li>
            <slot name="item" label={ item.label } data={item.data}>
                <!-- fallback -->
                { item.label }
            </slot>
            
            {#if item.children}
                <svelte:self items={ item.children }>
                    <svelte:fragment slot="item" let:label let:data>
                        <slot name="item"  {label} {data}>
                            <!-- fallback -->
                            { label }
                        </slot>
                    </svelte:fragment>
                </svelte:self>
            {/if}
        </li>
    {/each}
</ul>

<style>
    li {
        list-style: none;
    }
</style>